diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/global-router-interface.cc ns-3.47/src/internet/model/global-router-interface.cc
--- ns-3.46/src/internet/model/global-router-interface.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/global-router-interface.cc	2026-02-16 16:08:49.611230000 -0800
@@ -925,21 +1120,48 @@
           // all.
           //
           ClearBridgesVisited ();
-          Ipv4Address designatedRtrTemp = FindDesignatedRouterForLink (ndTemp);
+          IpAddress designatedRtrTemp = FindDesignatedRouterForLink (ndTemp);
 
           //
           // Let's double-check that any designated router we find out on our
           // network is really on our network.
           //
-          if (designatedRtrTemp != "255.255.255.255")
+         bool isRtrAllOnes = false;
+        if constexpr (IsIpv4)
+        {
+            if (designatedRtrTemp.IsBroadcast())
             {
-              Ipv4Address networkHere = addrLocal.CombineMask (maskLocal);
-              Ipv4Address networkThere = designatedRtrTemp.CombineMask (maskLocal);
-              NS_ABORT_MSG_UNLESS (networkHere == networkThere,
-                                   "GlobalRouter::ProcessSingleBroadcastLink(): Network number confusion (" <<
-                                   addrLocal << "/" << maskLocal.GetPrefixLength () << ", " <<
-                                   designatedRtrTemp << "/" << maskLocal.GetPrefixLength () << ")");
+                isRtrAllOnes = true;
             }
+        }
+        else
+        {
+            if (designatedRtrTemp == Ipv6Address::GetOnes())
+            {
+                isRtrAllOnes = true;
+            }
+        }
+
+        if (!isRtrAllOnes)
+        {
+            IpAddress networkHere;
+            IpAddress networkThere;
+            if constexpr (IsIpv4)
+            {
+                networkHere = addrLocal.CombineMask(maskLocal);
+                networkThere = designatedRtrTemp.CombineMask(maskLocal);
+            }
+            else
+            {
+                networkHere = addrLocal.CombinePrefix(maskLocal);
+                networkThere = designatedRtrTemp.CombinePrefix(maskLocal);
+            }
+            NS_ABORT_MSG_UNLESS(
+                networkHere == networkThere,
+                "GlobalRouter::ProcessSingleBroadcastLink(): Network number confusion ("
+                    << addrLocal << "/" << maskLocal.GetPrefixLength() << ", " << designatedRtr
+                    << "/" << maskLocal.GetPrefixLength() << ")");
+        }
           if (designatedRtrTemp < designatedRtr)
             {
               designatedRtr = designatedRtrTemp;
@@ -966,14 +1188,29 @@
       // According to OSPF, the Link ID is the IP network number of
       // the attached network.
       //
-      plr->SetLinkId (addrLocal.CombineMask (maskLocal));
-
+       if constexpr (IsIpv4)
+        {
+            plr->SetLinkId(addrLocal.CombineMask(maskLocal));
+        }
+        else
+        {
+            plr->SetLinkId(addrLocal.CombinePrefix(maskLocal));
+        }
       //
       // and the Link Data is the network mask; converted to Ipv4Address
       //
-      Ipv4Address maskLocalAddr;
-      maskLocalAddr.Set (maskLocal.Get ());
-      plr->SetLinkData (maskLocalAddr);
+IpAddress maskLocalAddr;
+        if constexpr (IsIpv4)
+        {
+            maskLocalAddr.Set(maskLocal.Get());
+        }
+        else
+        {
+            uint8_t buf[16];
+            maskLocal.GetBytes(buf);
+            maskLocalAddr.Set(buf);
+        }
+        plr->SetLinkData(maskLocalAddr);
       plr->SetMetric (metricLocal);
       pLSA->AddLinkRecord (plr);
       plr = 0;
@@ -1004,6 +1241,7 @@
       // OSPF says that the Link Data is this router's own IP address.
       //
       plr->SetLinkData (addrLocal);
+      plr->SetLinkLocData (addrLinkLocal);
       plr->SetMetric (metricLocal);
       pLSA->AddLinkRecord (plr);
       plr = 0;
@@ -1011,8 +1249,9 @@
 #endif
 }
 
+template <typename T>
 void
-GlobalRouter::ProcessPointToPointLink(Ptr<NetDevice> ndLocal, GlobalRoutingLSA* pLSA)
+GlobalRouter<T>::ProcessPointToPointLink(Ptr<NetDevice> ndLocal, GlobalRoutingLSA<T>* pLSA)
 {
     NS_LOG_FUNCTION(this << ndLocal << pLSA);
 
@@ -1025,23 +1264,56 @@
     //
     Ptr<Node> nodeLocal = ndLocal->GetNode();
 
-    Ptr<Ipv4> ipv4Local = nodeLocal->GetObject<Ipv4>();
+    Ptr<Ip> ipLocal = nodeLocal->GetObject<Ip>();
     NS_ABORT_MSG_UNLESS(
-        ipv4Local,
+        ipLocal,
         "GlobalRouter::ProcessPointToPointLink (): GetObject for <Ipv4> interface failed");
 
-    int32_t interfaceLocal = ipv4Local->GetInterfaceForDevice(ndLocal);
+    int32_t interfaceLocal = ipLocal->GetInterfaceForDevice(ndLocal);
     NS_ABORT_MSG_IF(
         interfaceLocal == -1,
         "GlobalRouter::ProcessPointToPointLink (): No interface index associated with device");
 
-    if (ipv4Local->GetNAddresses(interfaceLocal) > 1)
+    if ((ipLocal->GetNAddresses(interfaceLocal) == 0))
     {
-        NS_LOG_WARN("Warning, interface has multiple IP addresses; using only the primary one");
+        NS_LOG_LOGIC("Local interface " << interfaceLocal << " has no address");
+        return;
+    }
+
+    IpAddress addrLocal;
+    IpAddress addrLinkLocal; // this is the link local associated with the link for ipv6
+    if constexpr (IsIpv4)
+    {
+        if (ipLocal->GetNAddresses(interfaceLocal) > 1)
+        {
+            NS_LOG_WARN("Warning, interface has multiple IP addresses; using only the primary one");
+        }
+        addrLocal = ipLocal->GetAddress(interfaceLocal, 0).GetAddress();
+    }
+    else
+    {
+        addrLinkLocal = ipLocal->GetAddress(interfaceLocal, 0).GetAddress();
+        if (ipLocal->GetNAddresses(interfaceLocal) >
+            1) // if there is a globalUnicast address for the interface
+        {
+            addrLocal = ipLocal->GetAddress(interfaceLocal, 1).GetAddress();
+        }
+    }
+    IpMaskOrPrefix maskLocal;
+    if constexpr (IsIpv4)
+    {
+        maskLocal = ipLocal->GetAddress(interfaceLocal, 0).GetMask();
+    }
+    else
+    {
+        if (ipLocal->GetNAddresses(interfaceLocal) >
+            1) // if there is a globalUnicast address for the remote interface
+        {
+            maskLocal = ipLocal->GetAddress(interfaceLocal, 1).GetPrefix();
+        }
     }
-    Ipv4Address addrLocal = ipv4Local->GetAddress(interfaceLocal, 0).GetLocal();
     NS_LOG_LOGIC("Working with local address " << addrLocal);
-    uint16_t metricLocal = ipv4Local->GetMetric(interfaceLocal);
+    uint16_t metricLocal = ipLocal->GetMetric(interfaceLocal);
 
     //
     // Now, we're going to walk over to the remote net device on the other end of
@@ -1063,9 +1335,9 @@
     // with bridging.
     //
     Ptr<Node> nodeRemote = ndRemote->GetNode();
-    Ptr<Ipv4> ipv4Remote = nodeRemote->GetObject<Ipv4>();
+    Ptr<Ip> ipRemote = nodeRemote->GetObject<Ip>();
     NS_ABORT_MSG_UNLESS(
-        ipv4Remote,
+        ipRemote,
         "GlobalRouter::ProcessPointToPointLink(): GetObject for remote <Ipv4> failed");
 
     //
@@ -1082,28 +1354,57 @@
     //
     // We're going to need the remote router ID, so we might as well get it now.
     //
-    Ipv4Address rtrIdRemote = rtrRemote->GetRouterId();
+    IpAddress rtrIdRemote = rtrRemote->GetRouterId();
     NS_LOG_LOGIC("Working with remote router " << rtrIdRemote);
 
     //
     // Now, just like we did above, we need to get the IP interface index for the
     // net device on the other end of the point-to-point channel.
     //
-    int32_t interfaceRemote = ipv4Remote->GetInterfaceForDevice(ndRemote);
+    int32_t interfaceRemote = ipRemote->GetInterfaceForDevice(ndRemote);
     NS_ABORT_MSG_IF(interfaceRemote == -1,
                     "GlobalRouter::ProcessPointToPointLinks(): No interface index associated with "
                     "remote device");
 
+    if ((ipRemote->GetNAddresses(interfaceRemote) == 0))
+    {
+        NS_LOG_LOGIC("Remote interface " << interfaceRemote << " has no address");
+    }
     //
     // Now that we have the Ipv4 interface, we can get the (remote) address and
     // mask we need.
     //
-    if (ipv4Remote->GetNAddresses(interfaceRemote) > 1)
+
+    IpAddress addrRemote;
+    if constexpr (IsIpv4)
     {
-        NS_LOG_WARN("Warning, interface has multiple IP addresses; using only the primary one");
+        if (ipRemote->GetNAddresses(interfaceRemote) > 1)
+        {
+            NS_LOG_WARN("Warning, interface has multiple IP addresses; using only the primary one");
+        }
+        addrRemote = ipRemote->GetAddress(interfaceRemote, 0).GetAddress();
+    }
+    else
+    {
+        if (ipRemote->GetNAddresses(interfaceRemote) >
+            1) // if there is a globalUnicast address for the interface
+        {
+            addrRemote = ipRemote->GetAddress(interfaceRemote, 1).GetAddress();
+        }
+    }
+    IpMaskOrPrefix maskRemote;
+    if constexpr (IsIpv4)
+    {
+        maskRemote = ipRemote->GetAddress(interfaceRemote, 0).GetMask();
+    }
+    else
+    {
+        if (ipRemote->GetNAddresses(interfaceRemote) >
+            1) // if there is a globalUnicast address for the remote interface
+        {
+            maskRemote = ipRemote->GetAddress(interfaceRemote, 1).GetPrefix();
+        }
     }
-    Ipv4Address addrRemote = ipv4Remote->GetAddress(interfaceRemote, 0).GetLocal();
-    Ipv4Mask maskRemote = ipv4Remote->GetAddress(interfaceRemote, 0).GetMask();
     NS_LOG_LOGIC("Working with remote address " << addrRemote);
 
     //
@@ -1111,36 +1412,61 @@
     // link records; the first is a point-to-point record describing the link and
     // the second is a stub network record with the network number.
     //
-    GlobalRoutingLinkRecord* plr;
-    if (ipv4Remote->IsUp(interfaceRemote))
+    GlobalRoutingLinkRecord<T>* plr;
+
+    if (ipRemote->IsUp(interfaceRemote))
     {
         NS_LOG_LOGIC("Remote side interface " << interfaceRemote << " is up-- add a type 1 link");
 
-        plr = new GlobalRoutingLinkRecord;
+        plr = new GlobalRoutingLinkRecord<T>;
         NS_ABORT_MSG_IF(plr == nullptr,
                         "GlobalRouter::ProcessPointToPointLink(): Can't alloc link record");
-        plr->SetLinkType(GlobalRoutingLinkRecord::PointToPoint);
+        plr->SetLinkType(GlobalRoutingLinkRecord<T>::PointToPoint);
         plr->SetLinkId(rtrIdRemote);
         plr->SetLinkData(addrLocal);
+        plr->SetLinkLocData(addrLinkLocal);
         plr->SetMetric(metricLocal);
         pLSA->AddLinkRecord(plr);
         plr = nullptr;
     }
 
     // Regardless of state of peer, add a type 3 link (RFC 2328: 12.4.1.1)
-    plr = new GlobalRoutingLinkRecord;
+    // the only exception is if the remote interface has a link local address only, then it behaves
+    // as a router and not a host
+    if constexpr (!IsIpv4)
+    {
+        if (ipRemote->GetNAddresses(interfaceRemote) == 1 &&
+            ipRemote->GetAddress(interfaceRemote, 0).GetAddress().IsLinkLocal())
+        {
+            NS_LOG_LOGIC("The remote interface only has a link local address, not adding a type 3 "
+                         "link record");
+            return;
+        }
+    }
+
+    plr = new GlobalRoutingLinkRecord<T>;
     NS_ABORT_MSG_IF(plr == nullptr,
                     "GlobalRouter::ProcessPointToPointLink(): Can't alloc link record");
-    plr->SetLinkType(GlobalRoutingLinkRecord::StubNetwork);
+    plr->SetLinkType(GlobalRoutingLinkRecord<T>::StubNetwork);
     plr->SetLinkId(addrRemote);
-    plr->SetLinkData(Ipv4Address(maskRemote.Get())); // Frown
+    if constexpr (IsIpv4)
+    {
+        plr->SetLinkData(Ipv4Address(maskRemote.Get())); // Frown
+    }
+    else
+    {
+        uint8_t buf[16];
+        maskRemote.GetBytes(buf);
+        plr->SetLinkData(Ipv6Address(buf)); // Frown
+    }
     plr->SetMetric(metricLocal);
     pLSA->AddLinkRecord(plr);
     plr = nullptr;
 }
 
+template <typename T>
 void
-GlobalRouter::BuildNetworkLSAs(NetDeviceContainer c)
+GlobalRouter<T>::BuildNetworkLSAs(NetDeviceContainer c)
 {
     NS_LOG_FUNCTION(this << &c);
 
@@ -1156,32 +1482,48 @@
         Ptr<NetDevice> ndLocal = c.Get(i);
         Ptr<Node> node = ndLocal->GetNode();
 
-        Ptr<Ipv4> ipv4Local = node->GetObject<Ipv4>();
+        Ptr<Ip> ipLocal = node->GetObject<Ip>();
         NS_ABORT_MSG_UNLESS(
-            ipv4Local,
+            ipLocal,
             "GlobalRouter::ProcessPointToPointLink (): GetObject for <Ipv4> interface failed");
 
-        int32_t interfaceLocal = ipv4Local->GetInterfaceForDevice(ndLocal);
+        int32_t interfaceLocal = ipLocal->GetInterfaceForDevice(ndLocal);
         NS_ABORT_MSG_IF(
             interfaceLocal == -1,
             "GlobalRouter::BuildNetworkLSAs (): No interface index associated with device");
 
-        if (ipv4Local->GetNAddresses(interfaceLocal) > 1)
+        if (ipLocal->GetNAddresses(interfaceLocal) > 1)
         {
             NS_LOG_WARN("Warning, interface has multiple IP addresses; using only the primary one");
         }
-        Ipv4Address addrLocal = ipv4Local->GetAddress(interfaceLocal, 0).GetLocal();
-        Ipv4Mask maskLocal = ipv4Local->GetAddress(interfaceLocal, 0).GetMask();
+        IpAddress addrLocal;
+        if constexpr (IsIpv4)
+        {
+            addrLocal = ipLocal->GetAddress(interfaceLocal, 0).GetAddress();
+        }
+        else
+        {
+            addrLocal = ipLocal->GetAddress(interfaceLocal, 1).GetAddress();
+        }
+        IpMaskOrPrefix maskLocal;
+        if constexpr (IsIpv4)
+        {
+            maskLocal = ipLocal->GetAddress(interfaceLocal, 0).GetMask();
+        }
+        else
+        {
+            maskLocal = ipLocal->GetAddress(interfaceLocal, 1).GetPrefix();
+        }
 
-        auto pLSA = new GlobalRoutingLSA;
+        auto pLSA = new GlobalRoutingLSA<T>;
         NS_ABORT_MSG_IF(pLSA == nullptr,
                         "GlobalRouter::BuildNetworkLSAs(): Can't alloc link record");
 
-        pLSA->SetLSType(GlobalRoutingLSA::NetworkLSA);
+        pLSA->SetLSType(GlobalRoutingLSA<T>::NetworkLSA);
         pLSA->SetLinkStateId(addrLocal);
         pLSA->SetAdvertisingRouter(m_routerId);
         pLSA->SetNetworkLSANetworkMask(maskLocal);
-        pLSA->SetStatus(GlobalRoutingLSA::LSA_SPF_NOT_EXPLORED);
+        pLSA->SetStatus(GlobalRoutingLSA<T>::LSA_SPF_NOT_EXPLORED);
         pLSA->SetNode(node);
 
         //
@@ -1223,25 +1565,33 @@
             // Does the attached node have an ipv4 interface for the device we're probing?
             // If not, it can't play router.
             //
-            Ptr<Ipv4> tempIpv4 = tempNode->GetObject<Ipv4>();
-            int32_t tempInterface = tempIpv4->GetInterfaceForDevice(tempNd);
+            Ptr<Ip> tempIp = tempNode->GetObject<Ip>();
+            int32_t tempInterface = tempIp->GetInterfaceForDevice(tempNd);
 
             if (tempInterface != -1)
             {
-                Ptr<Ipv4> tempIpv4 = tempNode->GetObject<Ipv4>();
-                NS_ASSERT(tempIpv4);
-                if (!tempIpv4->IsUp(tempInterface))
+                Ptr<Ip> tempIp = tempNode->GetObject<Ip>();
+                NS_ASSERT(tempIp);
+                if (!tempIp->IsUp(tempInterface))
                 {
                     NS_LOG_LOGIC("Remote side interface " << tempInterface << " not up");
                 }
                 else
                 {
-                    if (tempIpv4->GetNAddresses(tempInterface) > 1)
+                    if (tempIp->GetNAddresses(tempInterface) > 1)
                     {
                         NS_LOG_WARN("Warning, interface has multiple IP addresses; using only the "
                                     "primary one");
                     }
-                    Ipv4Address tempAddr = tempIpv4->GetAddress(tempInterface, 0).GetLocal();
+                    IpAddress tempAddr;
+                    if constexpr (IsIpv4)
+                    {
+                        tempAddr = tempIp->GetAddress(tempInterface, 0).GetAddress();
+                    }
+                    else
+                    {
+                        tempAddr = tempIp->GetAddress(tempInterface, 1).GetAddress();
+                    }
                     NS_LOG_LOGIC("Adding " << tempAddr << " to Network LSA");
                     pLSA->AddAttachedRouter(tempAddr);
                 }
@@ -1259,8 +1609,9 @@
     }
 }
 
+template <typename T>
 NetDeviceContainer
-GlobalRouter::FindAllNonBridgedDevicesOnLink(Ptr<Channel> ch) const
+GlobalRouter<T>::FindAllNonBridgedDevicesOnLink(Ptr<Channel> ch) const
 {
     NS_LOG_FUNCTION(this << ch);
     NetDeviceContainer c;
@@ -1305,8 +1656,9 @@
 // will be us).  Of these, the router with the lowest IP address on the net device
 // connecting to the channel becomes the designated router for the link.
 //
-Ipv4Address
-GlobalRouter::FindDesignatedRouterForLink(Ptr<NetDevice> ndLocal) const
+template <typename T>
+GlobalRouter<T>::IpAddress
+GlobalRouter<T>::FindDesignatedRouterForLink(Ptr<NetDevice> ndLocal) const
 {
     NS_LOG_FUNCTION(this << ndLocal);
 
@@ -1317,7 +1669,15 @@
     NS_LOG_LOGIC("Looking for designated router off of net device " << ndLocal << " on node "
                                                                     << ndLocal->GetNode()->GetId());
 
-    Ipv4Address designatedRtr("255.255.255.255");
+    IpAddress designatedRtr;
+    if constexpr (IsIpv4)
+    {
+        designatedRtr = Ipv4Address::GetBroadcast();
+    }
+    else
+    {
+        designatedRtr = Ipv6Address::GetOnes();
+    }
 
     //
     // Look through all of the devices on the channel to which the net device
@@ -1364,24 +1724,32 @@
             //
             NS_LOG_LOGIC("Checking for router on bridge net device " << bnd);
             Ptr<GlobalRouter> rtr = nodeOther->GetObject<GlobalRouter>();
-            Ptr<Ipv4> ipv4 = nodeOther->GetObject<Ipv4>();
-            if (rtr && ipv4)
+            Ptr<Ip> ip = nodeOther->GetObject<Ip>();
+            if (rtr && ip)
             {
-                int32_t interfaceOther = ipv4->GetInterfaceForDevice(bnd);
+                int32_t interfaceOther = ip->GetInterfaceForDevice(bnd);
                 if (interfaceOther != -1)
                 {
                     NS_LOG_LOGIC("Found router on bridge net device " << bnd);
-                    if (!ipv4->IsUp(interfaceOther))
+                    if (!ip->IsUp(interfaceOther))
                     {
                         NS_LOG_LOGIC("Remote side interface " << interfaceOther << " not up");
                         continue;
                     }
-                    if (ipv4->GetNAddresses(interfaceOther) > 1)
+                    if (ip->GetNAddresses(interfaceOther) > 1)
                     {
                         NS_LOG_WARN("Warning, interface has multiple IP addresses; using only the "
                                     "primary one");
                     }
-                    Ipv4Address addrOther = ipv4->GetAddress(interfaceOther, 0).GetLocal();
+                    IpAddress addrOther;
+                    if constexpr (IsIpv4)
+                    {
+                        addrOther = ip->GetAddress(interfaceOther, 0).GetAddress();
+                    }
+                    else
+                    {
+                        addrOther = ip->GetAddress(interfaceOther, 1).GetAddress();
+                    }
                     designatedRtr = addrOther < designatedRtr ? addrOther : designatedRtr;
                     NS_LOG_LOGIC("designated router now " << designatedRtr);
                 }
@@ -1412,7 +1780,7 @@
                 }
 
                 NS_LOG_LOGIC("Recursively looking for routers down bridge port " << ndBridged);
-                Ipv4Address addrOther = FindDesignatedRouterForLink(ndBridged);
+                IpAddress addrOther = FindDesignatedRouterForLink(ndBridged);
                 designatedRtr = addrOther < designatedRtr ? addrOther : designatedRtr;
                 NS_LOG_LOGIC("designated router now " << designatedRtr);
             }
@@ -1428,24 +1796,32 @@
             // an internet stack that includes the Ipv4 interface.  If it doesn't
             //
             Ptr<GlobalRouter> rtr = nodeOther->GetObject<GlobalRouter>();
-            Ptr<Ipv4> ipv4 = nodeOther->GetObject<Ipv4>();
-            if (rtr && ipv4)
+            Ptr<Ip> ip = nodeOther->GetObject<Ip>();
+            if (rtr && ip)
             {
-                int32_t interfaceOther = ipv4->GetInterfaceForDevice(ndOther);
+                int32_t interfaceOther = ip->GetInterfaceForDevice(ndOther);
                 if (interfaceOther != -1)
                 {
-                    if (!ipv4->IsUp(interfaceOther))
+                    if (!ip->IsUp(interfaceOther))
                     {
                         NS_LOG_LOGIC("Remote side interface " << interfaceOther << " not up");
                         continue;
                     }
                     NS_LOG_LOGIC("Found router on net device " << ndOther);
-                    if (ipv4->GetNAddresses(interfaceOther) > 1)
+                    if (ip->GetNAddresses(interfaceOther) > 1)
                     {
                         NS_LOG_WARN("Warning, interface has multiple IP addresses; using only the "
                                     "primary one");
                     }
-                    Ipv4Address addrOther = ipv4->GetAddress(interfaceOther, 0).GetLocal();
+                    IpAddress addrOther;
+                    if constexpr (IsIpv4)
+                    {
+                        addrOther = ip->GetAddress(interfaceOther, 0).GetAddress();
+                    }
+                    else
+                    {
+                        addrOther = ip->GetAddress(interfaceOther, 1).GetAddress();
+                    }
                     designatedRtr = addrOther < designatedRtr ? addrOther : designatedRtr;
                     NS_LOG_LOGIC("designated router now " << designatedRtr);
                 }
@@ -1461,8 +1837,9 @@
 // that has a GlobalRouter interface aggregated.  Life gets more complicated
 // when there is a bridged net device on the other side.
 //
+template <typename T>
 bool
-GlobalRouter::AnotherRouterOnLink(Ptr<NetDevice> nd) const
+GlobalRouter<T>::AnotherRouterOnLink(Ptr<NetDevice> nd) const
 {
     NS_LOG_FUNCTION(this << nd);
 
@@ -1564,8 +1941,9 @@
     return false;
 }
 
+template <typename T>
 uint32_t
-GlobalRouter::GetNumLSAs() const
+GlobalRouter<T>::GetNumLSAs() const
 {
     NS_LOG_FUNCTION(this);
     return m_LSAs.size();
@@ -1574,8 +1952,9 @@
 //
 // Get the nth link state advertisement from this router.
 //
+template <typename T>
 bool
-GlobalRouter::GetLSA(uint32_t n, GlobalRoutingLSA& lsa) const
+GlobalRouter<T>::GetLSA(uint32_t n, GlobalRoutingLSA<T>& lsa) const
 {
     NS_LOG_FUNCTION(this << n << &lsa);
     NS_ASSERT_MSG(lsa.IsEmpty(), "GlobalRouter::GetLSA (): Must pass empty LSA");
@@ -1591,7 +1970,7 @@
     {
         if (j == n)
         {
-            GlobalRoutingLSA* p = *i;
+            GlobalRoutingLSA<T>* p = *i;
             lsa = *p;
             return true;
         }
@@ -1600,20 +1979,22 @@
     return false;
 }
 
+template <typename T>
 void
-GlobalRouter::InjectRoute(Ipv4Address network, Ipv4Mask networkMask)
+GlobalRouter<T>::InjectRoute(IpAddress network, IpMaskOrPrefix networkMask)
 {
     NS_LOG_FUNCTION(this << network << networkMask);
-    auto route = new Ipv4RoutingTableEntry();
+    auto route = new IpRoutingTableEntry();
     //
     // Interface number does not matter here, using 1.
     //
-    *route = Ipv4RoutingTableEntry::CreateNetworkRouteTo(network, networkMask, 1);
+    *route = IpRoutingTableEntry::CreateNetworkRouteTo(network, networkMask, 1);
     m_injectedRoutes.push_back(route);
 }
 
-Ipv4RoutingTableEntry*
-GlobalRouter::GetInjectedRoute(uint32_t index)
+template <typename T>
+GlobalRouter<T>::IpRoutingTableEntry*
+GlobalRouter<T>::GetInjectedRoute(uint32_t index)
 {
     NS_LOG_FUNCTION(this << index);
     if (index < m_injectedRoutes.size())
@@ -1633,15 +2014,17 @@
     return nullptr;
 }
 
+template <typename T>
 uint32_t
-GlobalRouter::GetNInjectedRoutes()
+GlobalRouter<T>::GetNInjectedRoutes()
 {
     NS_LOG_FUNCTION(this);
     return m_injectedRoutes.size();
 }
 
+template <typename T>
 void
-GlobalRouter::RemoveInjectedRoute(uint32_t index)
+GlobalRouter<T>::RemoveInjectedRoute(uint32_t index)
 {
     NS_LOG_FUNCTION(this << index);
     NS_ASSERT(index < m_injectedRoutes.size());
@@ -1659,18 +2042,32 @@
     }
 }
 
+template <typename T>
 bool
-GlobalRouter::WithdrawRoute(Ipv4Address network, Ipv4Mask networkMask)
+GlobalRouter<T>::WithdrawRoute(IpAddress network, IpMaskOrPrefix networkMask)
 {
     NS_LOG_FUNCTION(this << network << networkMask);
     for (auto i = m_injectedRoutes.begin(); i != m_injectedRoutes.end(); i++)
     {
-        if ((*i)->GetDestNetwork() == network && (*i)->GetDestNetworkMask() == networkMask)
+        if constexpr (IsIpv4)
         {
-            NS_LOG_LOGIC("Withdrawing route to network/mask " << network << "/" << networkMask);
-            delete *i;
-            m_injectedRoutes.erase(i);
-            return true;
+            if ((*i)->GetDestNetwork() == network && (*i)->GetDestNetworkMask() == networkMask)
+            {
+                NS_LOG_LOGIC("Withdrawing route to network/mask " << network << "/" << networkMask);
+                delete *i;
+                m_injectedRoutes.erase(i);
+                return true;
+            }
+        }
+        else
+        {
+            if ((*i)->GetDestNetwork() == network && (*i)->GetDestNetworkPrefix() == networkMask)
+            {
+                NS_LOG_LOGIC("Withdrawing route to network/mask " << network << "/" << networkMask);
+                delete *i;
+                m_injectedRoutes.erase(i);
+                return true;
+            }
         }
     }
     return false;
@@ -1680,8 +2077,9 @@
 // Link through the given channel and find the net device that's on the
 // other end.  This only makes sense with a point-to-point channel.
 //
+template <typename T>
 Ptr<NetDevice>
-GlobalRouter::GetAdjacent(Ptr<NetDevice> nd, Ptr<Channel> ch) const
+GlobalRouter<T>::GetAdjacent(Ptr<NetDevice> nd, Ptr<Channel> ch) const
 {
     NS_LOG_FUNCTION(this << nd << ch);
     NS_ASSERT_MSG(ch->GetNDevices() == 2,
@@ -1714,8 +2112,9 @@
 //
 // Decide whether or not a given net device is being bridged by a BridgeNetDevice.
 //
+template <typename T>
 Ptr<BridgeNetDevice>
-GlobalRouter::NetDeviceIsBridged(Ptr<NetDevice> nd) const
+GlobalRouter<T>::NetDeviceIsBridged(Ptr<NetDevice> nd) const
 {
     NS_LOG_FUNCTION(this << nd);
 
@@ -1759,8 +2158,9 @@
 //
 // Start a new enumeration of an L2 broadcast domain by clearing m_bridgesVisited
 //
+template <typename T>
 void
-GlobalRouter::ClearBridgesVisited() const
+GlobalRouter<T>::ClearBridgesVisited() const
 {
     m_bridgesVisited.clear();
 }
@@ -1768,8 +2168,9 @@
 //
 // Check if we have already visited a given bridge net device by searching m_bridgesVisited
 //
+template <typename T>
 bool
-GlobalRouter::BridgeHasAlreadyBeenVisited(Ptr<BridgeNetDevice> bridgeNetDevice) const
+GlobalRouter<T>::BridgeHasAlreadyBeenVisited(Ptr<BridgeNetDevice> bridgeNetDevice) const
 {
     for (auto iter = m_bridgesVisited.begin(); iter != m_bridgesVisited.end(); ++iter)
     {
@@ -1785,11 +2186,28 @@
 //
 // Remember that we visited a bridge net device by adding it to m_bridgesVisited
 //
+template <typename T>
 void
-GlobalRouter::MarkBridgeAsVisited(Ptr<BridgeNetDevice> bridgeNetDevice) const
+GlobalRouter<T>::MarkBridgeAsVisited(Ptr<BridgeNetDevice> bridgeNetDevice) const
 {
     NS_LOG_FUNCTION(this << bridgeNetDevice);
     m_bridgesVisited.push_back(bridgeNetDevice);
 }
 
+/**Explicit initialize the template classes */
+/** @brief Stream insertion operator
+ *  @returns the reference to the output stream
+ */
+template std::ostream& operator<< <Ipv4Manager>(std::ostream&, GlobalRoutingLSA<Ipv4Manager>&);
+template class GlobalRoutingLinkRecord<Ipv4Manager>;
+template class GlobalRoutingLSA<Ipv4Manager>;
+/** @brief Stream insertion operator
+ *  @returns the reference to the output stream
+ */
+template std::ostream& operator<< <Ipv6Manager>(std::ostream&, GlobalRoutingLSA<Ipv6Manager>&);
+template class GlobalRoutingLinkRecord<Ipv6Manager>;
+template class GlobalRoutingLSA<Ipv6Manager>;
+NS_OBJECT_TEMPLATE_CLASS_DEFINE(GlobalRouter, Ipv4Manager);
+NS_OBJECT_TEMPLATE_CLASS_DEFINE(GlobalRouter, Ipv6Manager);
+
 } // namespace ns3
